VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ObjectStore"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit


Public Enum xopErrors
    errMSXMLerror = vbObjectError + 1
    errNoPeristentData
    errUnknownType
    errNoMultiDimArraysSupported
End Enum


Public Event RequestObject(ByVal Classname As String, ByRef newObject As IXOP)


Private m_xop As MSXML.DOMDocument
Private m_objectCache As Collection


Public Function Deserialize(ByVal xopSource As String) As Object
    Set m_xop = New MSXML.DOMDocument
    
    m_xop.async = False
    If Left$(xopSource, 1) = "<" Then
        m_xop.loadXML xopSource
    Else
        m_xop.Load xopSource
    End If
    
    If m_xop.parseError.errorCode = 0 Then
        Set m_objectCache = New Collection
        
        Set Deserialize = DeserializeObject(m_xop.documentElement.selectSingleNode("Object").Attributes.getNamedItem("id").nodeValue)
        
        Set m_objectCache = Nothing
    Else
        Dim errMsg As String
        errMsg = "Error loading XOP-Source! Reason: " & m_xop.parseError.reason & "XML-Source (line/char " & m_xop.parseError.Line & "/" & m_xop.parseError.linepos & "): '" & m_xop.parseError.srcText & "'"
        Set m_xop = Nothing
        Err.Raise errMSXMLerror, "Load", errMsg
    End If
    
    Set m_xop = Nothing
End Function


Public Function Serialize(ByVal rootObject As IXOP, Optional ByVal returnXMLDOM As Boolean = True) As Variant
    Set m_xop = New MSXML.DOMDocument
    Set m_objectCache = New Collection
    
    m_xop.loadXML "<ObjectStore version=""1.0"" xmlns=""x-schema:xop-schema.xml""/>"
    
    SerializeObject rootObject
    
    Set m_objectCache = Nothing
    
    If returnXMLDOM Then
        Set Serialize = m_xop
    Else
        Serialize = m_xop.XML
    End If
    
    Set m_xop = Nothing
End Function


'Public Property Get XML() As String
'    If m_xop Is Nothing Then Err.Raise errNoPeristentData, "XML", "No persistent data has been loaded!"
'    XML = m_xop.XML
'End Property


'-----------------------------------------------------------------


Friend Function DeserializeObject(ByVal objId As String) As Object
    Dim obj As IXOP, objNode As MSXML.IXMLDOMNode
    
    On Error Resume Next
    Set obj = m_objectCache(objId)
    If Err <> 0 Then
        On Error GoTo 0
        Set objNode = m_xop.documentElement.selectSingleNode("Object[@id='" & objId & "']")
        
        Set obj = CreateObjectFromClassname(objNode.Attributes.getNamedItem("classname").nodeValue)
        m_objectCache.Add obj, objId
            
        Dim op As ObjectProperties
        Set op = New ObjectProperties
        op.Constructor Me, objNode
        
        obj.LoadProperties op
        
        Set op = Nothing
    End If
    
    Set DeserializeObject = obj
End Function


Friend Function SerializeObject(ByVal rootObject As IXOP) As String
    Dim obj As IXOP, id As String
    
    On Error Resume Next
    id = "id" & ObjPtr(rootObject)
    Set obj = m_objectCache(id)
    If Err <> 0 Then
        On Error GoTo 0
        m_objectCache.Add rootObject, id
        
        Dim objNode As MSXML.IXMLDOMNode, a As MSXML.IXMLDOMAttribute
        Set objNode = m_xop.createNode(NODE_ELEMENT, "Object", m_xop.documentElement.namespaceURI)
        
        Set a = m_xop.createAttribute("id")
            a.nodeValue = id
            objNode.Attributes.setNamedItem a
        Set a = m_xop.createAttribute("classname")
            a.nodeValue = rootObject.Classname
            objNode.Attributes.setNamedItem a
        
        m_xop.documentElement.appendChild objNode

        Dim op As ObjectProperties
        Set op = New ObjectProperties
        op.Constructor Me, objNode
        
        rootObject.StoreProperties op
        
        Set op = Nothing
    End If
    
    SerializeObject = id
End Function


'-------------------------------------------


Private Function CreateObjectFromClassname(ByVal Classname As String) As IXOP
    Dim obj As IXOP
    
    ' ask the application for an instance of the objects class
    RaiseEvent RequestObject(Classname, obj)
    
    ' if no instance was provided try to create one
    If obj Is Nothing Then
        On Error Resume Next
        Set obj = CreateObject(Classname)
    End If

    Set CreateObjectFromClassname = obj
End Function


